#include "defs.inc"

TMP     EQU 0E7FFH
INADR   EQU TMP-2

  ORG 0D000H

ENTRY:
  lxi h,BUF
  lxi b,2048-256
clrmem:
  mvi m,0
  inx h
  dcx b
  mov a,c
  ora b
  jnz clrmem
  CALL FS_RST
LOOP: LXI SP,0E6CFH

     ;  梥
     XRA  A
     STA  0FFFEh

     ; 뢮  ஫  ࠭
     LXI  H, aHello
     CALL 0C818h

     ; ॢ ப
     lxi  h, aCrLf
     CALL 0C818h

     ; ᪠ 䠩 SHELL.RKS   ப
     LXI  H, aShellRks
     LXI  D, aEmpty
     CALL CmdExec
     PUSH PSW

     ; 訡 - 䠩  
;     CPI  04h
;     JNZ  Error2

     ; 뢮 ᮮ饭 "   SHELL.RKS"
     LXI  H, aErrorShellRks
     CALL 0C818h
     JMP  $

aHello:         .db 13,"SD BIOS V0.1",13,10
aSdController:  .db "SD CONTROLLER ",0
aCrLf:          .db 13,10,0
aErrorShellRks: .db "fajl ne najden "
aShellRks:      .db "SPETS_BR.RKS",0
;aShellRks:      .db "SHELL.RKS",0

ALLFILS:        .db "*",0
PREVDIR:        .db "..",0

#include "sd_proc.inc"
#include "fs_proc.inc"

SELF_NAME    = BUF ;$-512 ;  ( 256 )
CMD_LINE     = BUF+256 ;$-256 ;  ப 256 

;----------------------------------------------------------------------------

aError:    .db "o{ibka SD "
aEmpty:    .db 0

;----------------------------------------------------------------------------
;  ⠭ ,    ᯮ祭  ᡮ

Error:     
     ; 奬 砫쭮 ᪠
     EI
     LXI  H, 0FF03h
     MVI  M, 82h
     
     ; 樠 ⥪
;     LXI  SP, 07FFFh

     ; ࠭塞  訡
     PUSH PSW

     ; ⪠ ࠭
;     MVI  C, 1Fh
;     CALL 0C809h
     
Error2:
     ; 뢮 ⥪ " SD "
     LXI  H, aError
     CALL PRINT

     ; 뢮  訡
     POP  PSW  ; xsd    訡, ⮫쪮 ਧ,  訡 뫠  䫠 'C'
     CALL 0C815h

    LXI H,aCrLf
    CALL PRINT

     ; ᭥
;     JMP  $
   RET

;----------------------------------------------------------------------------

BiosEntry:
     PUSH H             ; 1
     LXI  H, JmpTbl     ; 2
     ADD  L             ; 1
     MOV  L, A          ; 1
     MOV  L, M          ; 1
     XTHL               ; 1
     RET                ; 1

;----------------------------------------------------------------------------
; ࠭ D600.  室 JmpTbl  ।  ࠭
  ORG 0D600H

JmpTbl:
     .db CmdExec1           ; 0 HL- 䠩, DE- ப  / A- 訡
     .db CmdFind1           ; 1 HL- 䠩, DE-ᨬ 䠩  㧪, BC- / HL-᪮쪮 㧨, A- 訡
     .db CmdOpenDelete1     ; 2 D-०, HL- 䠩 / A- 訡
     .db CmdSeekGetSize1    ; 3 B-०, DE:HL- / A- 訡, DE:HL-
     .db CmdRead1           ; 4 HL-ࠧ, DE- / HL-᪮쪮 㧨, A- 訡
     .db CmdWrite1          ; 5 HL-ࠧ, DE- / A- 訡
     .db CmdMove1           ; 6 HL-, DE- / A- 訡
;----------------------------------------------------------------------------
;  ࠢ쭮, ⮡   䨣,   ࠢ    2 ⠬
CmdExec1:
 JMP CmdExec
CmdFind1:
 JMP CmdFind
CmdOpenDelete1:
 JMP CmdOpenDelete
CmdSeekGetSize1:
 JMP CmdSeekGetSize
CmdRead1:
 JMP CmdRead
CmdWrite1:
 JMP CmdWrite
CmdMove1:
 JMP CmdMove

; HL- 䠩, DE- ப / A- 訡

CmdExec:
     ;  H    
     ;    㦭 뤥 ⮫쪮  䠩
  LXI D,CWD+1
Ce1:
  LDAX D
  CPI 00H
  JZ Ce2
  INX H
  INX D
  JMP Ce1
Ce2:
  XCHG   
;  ஢  ⠫    
  LDAX D
  CPI 2FH
  JNZ Ce3
  INX D
Ce3:
  LXI H,LINEBUF
  CALL STRCPY
  LXI D,LINEBUF
  CALL F_OPEN
  LXI H,aErrorShellRks
  JC Error
  LXI B,4
  LXI H,LINEBUF
  CALL F_READ
  LXI H,LINEBUF
  MOV A,M
  CPI 0E6H
  JNZ RUNF2
  LXI B,1
  LXI H,LINEBUF+4
  CALL F_READ
  LXI H,LINEBUF+1
RUNF2:
;塞 ᪮쪮, 㤠    ⥪   ணࠬ
  MOV e,M
  INX H
  MOV d,M
  INX H
  MOV c,M
  INX H
  MOV A,M
  SUB E
  MOV b,A
  MOV A,c
  SBB D
  MOV c,A
  INX B
  XCHG
  PUSH H
  CALL F_READ

     POP H ; ६  
     ; 樠 ⥪ (筮 ⠭⭮ 
     LXI  SP, 07FFFh
     PUSH H ; ࠭塞   ⥪  

     ; ⪠ ࠭
     MVI  C, 1Fh
     CALL 0C809h

     ; ன  ணࠬ
     MVI  A, 1    ;  ஫
     LXI  B, BiosEntry  ; 窠 室 SD BIOS
     LXI  D, SELF_NAME  ; ⢥ 
     LXI  H, CMD_LINE   ;  ப

     ;  㦥 ணࠬ
     RET

;----------------------------------------------------------------------------
; HL-, DE-ᨬ 䠩  㧪, BC- / HL-᪮쪮 㧨, A- 訡

CmdFind:
;----------------------------
;㦭 ࠢ 室騩   HL  ⥪騩   xsd  CWD
;᫨ (HL)==(CWD)  室  Fnd1 
;᫨ (HL)>(CWD)  室  ⠫ ⮪  (HL)-(CWD)
;᫨ (HL)<(CWD)  室  ⠫ '..'
;  㤥 ࠡ  室 +/-  ஢ ⠫  ⥪饣
;1(Fnd0) ஢  0 HL, ᫨  0,  goto 2,  ஢ઠ  0 CWD, ᫨  0,  goto 2, 
;    ࠢ - JMP Fnd1
;2(Fnd4)  ᫥⥫쭮  HL CWD, ᫨ 0,  ६ HL  CWD  goto 1,  goto 3
;3 ᫨  䫠 ७,  HL<CWD  室  ⠫ '..',  室   ⠫
;
  PUSH B ;࠭  ᯨ᪠   䠩
  LXI D,CWD+1
Fnd0:
  MVI A, 0 ; ஢  0  
  CMP M ;  HL  (HL)
  JZ Fnd2 ; 室, HL==0
Fnd4:
  LDAX D 
  CMP M
  JNZ Fnd3
  INX H
  INX D
  JMP Fnd0 ;  㫨  ࠢ, 塞
Fnd3:
  JC Fnd5; H ᬥ饭    ⠫,   砫  '/',   
  LXI H,PREVDIR ; 室  ஢ 

Fnd5:
  XCHG ; ⠫ , 㦭 ᬥ ⠫, ४ H  D
  LDAX D
  CPI 02FH
  JNZ Fnd6
  INX D ; ய᪠ 
Fnd6:
  PUSH D
  CALL FS_CHDIR ;  D 
  POP D
  JMP Fnd1

Fnd2:
;  PUSH H
  LXI H,CWD+1
  MVI A, 0 ; ஢  0  
  CMP M ;  HL  (CWD)
;  POP H
  JNZ Fnd6 ; 室, HL!=0, ⠫ 

;----------------------------

Fnd1:
  LXI D,ALLFILS ;  D '*'  ᪠ ᯨ᪠ 䠩
  ; ⠭  ᯨ᪠  䠩
  POP H
  SHLD INADR
     ; 稪
  LXI H,TMP
  MVI  A, 0
  MOV M,A ;樠஢  ࠭ 稪 䠩

  CALL FS_FNDF ;  D ⠫  ᪠
  JC C_DIRNO
C_DIR1: ; ஢ઠ  稥     䠩  ਡ 䠩
  PUSH H
  LXI B,11
  DAD B
  MOV A,M
  POP H
  ANI 8
  JNZ C_DIR2
  ;    䠩/⠫...
  PUSH H ; H  D  ᯮ짮, ࠭...
  PUSH D
  XCHG
  LDAX D
  CPI 02EH
  JNZ NOT_DIR
  XCHG
  POP D
  POP H
  JMP C_DIR2
NOT_DIR:
  LHLD INADR;  HL  㤠 ᪫뢠 ⥫  䠩, ⥫ ࠧ஬ 20 
  MVI B,12 ;  D 稭 ⠭  FAT ⥫  䠩, ⥫ ࠧ஬ 32 
 ; 뢠 , ७  ਡ
FLC_LOOP: 
  LDAX D
  INX D
  MOV M,A
  INX H
  DCR B
  JNZ FLC_LOOP

  MVI B,16 ;ப뢠 㦭 8    8  ய᪠,  ,  㯮,...
  INX D
  DCR B
  JNZ $-2
  
  MVI B,4 ; ࠫ  ࠧ 䠩, ...
FLC_LOOP1: 
  LDAX D
  INX D
  MOV M,A
  INX H
  DCR B
  JNZ FLC_LOOP1

  MVI B,10 ;    ६   ᫥   䠩, ⠪  㯮...
  DCX D
  DCR B
  JNZ $-2

  MVI B,4 ;  ६   ᫥   䠩
FLC_LOOP2: 
  LDAX D
  INX D
  MOV M,A
  INX H
  DCR B
  JNZ FLC_LOOP2

  SHLD INADR ; . ࠭  ᫥ 樨
  XCHG
  POP D
  POP H

  PUSH H
  LXI H,TMP ;㢥稫  1 稪 䠩
  MOV A,M
  INR A
  MOV M,A
  POP H

C_DIR2: CALL FS_FNDN
  JNC C_DIR1
 ;⠭ 稪 䠩
  LXI H,TMP
  MOV  L,M
     ;  訡
     MVI  A, 0
  MOV H,A
  RET
C_DIRNO:
     ;  訡
     MVI  A, 1

    RET
;----------------------------------------------------------------------------
; D-०, HL- 䠩 / A- 訡

CmdOpenDelete: 
;     LXI  H, 0
     ;  訡
     MVI  A, 0

    RET     
;----------------------------------------------------------------------------
; B-०, DE:HL- / A- 訡, DE:HL-

CmdSeekGetSize:
;     LXI  H, 0
     ;  訡
     MVI  A, 0

    RET     
;----------------------------------------------------------------------------
; HL-ࠧ, DE- / HL-᪮쪮 㧨, A- 訡

CmdRead:
;     LXI  H, 0
     ;  訡
     MVI  A, 0

    RET     
;----------------------------------------------------------------------------
; HL-ࠧ, DE- / A- 訡

CmdWrite:
;     LXI  H, 0
     ;  訡
     MVI  A, 0

    RET     
;----------------------------------------------------------------------------
; HL-, DE- / A- 訡

CmdMove:     
;     LXI  H, 0
     ;  訡
     MVI  A, 0

    RET     
;----------------------------------------------------------------------------
  END
